{
  a Z-80 assembly language compiler for ZX-SPECTRUM (48/128/512/1024)

  DESCRIPT: source compiler.

                                 was written by SCREW/OHG/CM
                                   all rights reserved
}
Program C_Compiler;
Uses C_Z80Codes, C_Z80Labels,C_ErrHandle,
     C_Z80Macros,C_Z80Equals,C_Z80Ram,crt2;
{$I C_Z80ERR.pas} {include errors definition }

const err_filename='error.log';

Var     is_org:boolean;  { ORG flag }
    is_comment:boolean;  { comment flag }
         start:word;
      prg_name:string;  {name of generation codes}
     curr_page:integer; {current selected ram_page}
      err_file:text; {error log file}

Procedure Store_Code;
Begin
 if (pass=2) and (org<>start) then Begin
                                   {STORE COMPILED SOURCE}
                                   RAM_Store(prg_name,start,org-start);
{                                   writeln('Code: ',start,', ',org-start)
 }                   end;
 start:=org
end;

Function comment(line:string):string;
Var i,j,len:integer;
    s,s1:string;
Begin
 s:=line+' '; s1:='';
 { comments }
 len:=length(s);
 i:=1; j:=1;
 while (i<len) do
  Begin
   if not is_comment then
    if (s[i]='/') and (s[i+1]='*') then Begin
                                         is_comment:=true;
                                         inc(i)
                                        end
                                   else s1:=s1+s[i];
   if is_comment then
    if (s[i]='*') and (s[i+1]='/') then Begin
                                         is_comment:=false;
                                         inc(i)
                                        end;
   inc(i)
  end;
 { remarks }
 s1:=s1+' ';
 len:=length(s1);
 i:=1;
 while(i<len)do
  if (s1[i]='/') and (s1[i+1]='/') then Begin
                                         s1:=copy(s1,1,i-1);
                                         break
                                        end
                                   else inc(i);
 comment:=s1
end;


Procedure Compiler_Init;
Begin
 is_comment:=false; { commentary init }
     is_org:=false; { org init }
 org:=0; start:=0;
 pass:=1; prg_name:='';
 Table_Init(lab);
 Macro_Init(mac);
 EQU_Init(equ);
 RAM_Init
end;

Procedure Compiler_Reinit;
Begin
 is_comment:=false; { commentary init }
     is_org:=false; { org init }
 org:=0; start:=0;
 inc(pass); prg_name:='';
 Macro_Reinit(mac);
 Table_Reinit(lab)
end;

Procedure Compiler_Deinit;
Begin
 Ram_Deinit;
 EQU_Deinit(equ);
 Macro_Deinit(mac);
 Table_Deinit(lab)
end;

Procedure File_Compile(name:string); forward;

Procedure Compile(line:string; src_name:string; line_number:integer);
Var i,len,err:integer;
    s,s1,s2,s3,s4:string;
    s_org:string;
        w:word;
     tmp_strn:string;
     tmp_bool:boolean;
     tmp_int1,
     tmp_int2:integer;
Begin
 s:=line;
 s:=comment(s);
 ToUpper(s);
 if s='' then exit;
repeat
 Remove_Errors;
 CodeReset;

 EQU_Use(equ, s);

 { MACRO addition }
 if is_next_add then Begin
                      Macro_Add(mac,s);
                      exit
                     end;

 str(org,s_org);
 s:=Replace(s,'$',s_org);

 i:=1;
 s1:=GetWord(s,i);
 if s1<>'' then Begin
                 s2:=GetWord(s,i);
                 if s2='MACRO' then Macro_Add(mac,s);
                 if is_next_add then exit
                end;
 {if label present, then put it to the 'lab' table}
 set_Label(lab,s, org);

 { Code generation }
 i:=1;
 s1:=GetWord(s,i);
 s2:=GetWord(s,i);
 s3:=GetWord(s,i);
 s4:=GetWord(s,i);
{   write('       ',s);
   for i:=1 to 4-((length(s)-1) div 8) do write(chr(9));
 }
 { set ORG, if need }
 if s1='ORG' then Begin
                  readValue(s2,i,err);
                  if err<>0 then Error(SYNTAX_ERROR)
                            else Begin
    {                              writeln(s);
     }                             if not is_org then Begin
                                                     start:=i;
                                                     org:=i;
                                                     is_org:=true
                                                    end;
                                  Store_code;
                                  prg_name:=s3;
                                  start:=i;
                                  org:=i
                                 end;
                  s1:=''  {skip translator}
                 end;
 { procedure, if need }
 if (s1<>'') and (s2='') and get_Label(lab,s1,w) then s:='CALL '+s1;

 if (s1='ALIGN') then Begin
                       readValue(s2,len,err);
                       if err<>0 then Error(SYNTAX_ERROR)
                                      else Begin
                                            s1:='DS';
                                            i:=org mod len;
                                            if i<>0 then i:=len-i;
                                            str(i,s2)
                                           end
                      end;

 if (s1='DS') then Begin
                    readValue(s2,len,err);
                    if err<>0 then Error(SYNTAX_ERROR)
                              else Begin
                                    bytes.code_set[1]:=0;
                                    bytes.code_len:=1;
                                    for i:=1 to len do Begin
                                                        Ram_put(org);
                                                        inc(org)
                                                       end
                                   end;
                    s1:=''; {skip translator}
                   end;
 {include binary files}
 if (s1='#BIN_LOAD') and (s2<>'') then Begin
                                       Ram_Insert(s2,org);
                                       s1:=''
                                      end;
 {store binary files}
 if (s1='#BIN_SAVE') and (s2<>'') and
    (s3<>'') and (s4<>'') then Begin
                                readValue(s3,i,err);
                                if err=0 then readValue(s4,len,err);
                                if err<>0 then Error(SYNTAX_ERROR)
                                else if pass=2 then RAM_Store(s2,i,len);
                                s1:=''
                               end;
 {include source files}
 if (s1='#INCLUDE') and (s2<>'') then Begin
                                       File_Compile(s2);
                                       s1:=''
                                      end;
 if s1<>'' then
   {Macros skip}
     { if 's' is not eqyal then try to translate it }
      if not EQU_Add(equ,s) then Translate(s);

   { open macros }
  if get_Error <> OK then { if translate failed, then try to macros using }
   if (s1<>'') and not is_next_macro then Macro_Get(mac,s); {first start}

 {try to call procedure, may it true ?}
 if (get_Error=UNKNOWN_MNEMONIC) and not is_next_macro then
  if (pass=1) and (s2='') and (s1<>'') then Begin
                                             Remove_Errors;
                                             s:='CALL '+s1;
                                             Translate(s)
                                             end;

 if s1<>'' then
 if Get_error = OK then with bytes do
                         Begin
                          if (not is_org) and (code_len>0) then Error(ORG_IS_NOT_ASSIGNED);
                          if pass=2 then Ram_Put(org);
                          org:=org + code_len;
{                          write(org-code_len,'>  ');
                          for i:=1 to code_len do
                           if i<>code_len then write(code_set[i],', ')
                                          else write(code_set[i],'.')
 }                        end;

  { Hide macros }
  if Translator_Error and isMacros(mac,s1) then Remove_Errors;

  { get next source line from macros, if it is open}
  if is_next_macro then Begin
                         s:=Macro_Get(mac,s);
                         i:=1; s1:=GetWord(s,i); { s1 - mnemonic in next line}
{                         if s1:=mac^.macs[ mac^.last_found ].
 }                        tmp_int1:=mac^.last_found;
                         tmp_int2:=curr_numb;
                         tmp_bool:=is_next_macro;
                         tmp_strn:=curr_params;
                         is_next_macro:=false;
                         if (s<>'') then Macro_Get(mac,s1);
                         { macros recursive calls }
                         if is_next_macro then Begin
                                                is_next_macro:=false;
{                                                writeln;}
                                                Compile(s, src_name, line_number);
                                                {code now generated, skip
                                                 this source line}
                                                s:=''
                                               end;
                         curr_params:=tmp_strn;
                         curr_numb:=tmp_int2;
                         mac^.last_found:=tmp_int1;
                         is_next_macro:=tmp_bool;
                        end;
  Begin
   s1:=W_Error; { print error, if any occured. }
   str(line_number,s2);
   if s1<>'' then Begin
                   writeln(err_file,'ERROR: in file ('+src_name+'), in line '+s2+': '+s1);
                   writeln(err_file,'       '+line);
                   Inc_counter
                  end
  end;
{ writeln}
 until not is_next_macro;
end;

{ a just one pass on 'name' file }
Procedure File_Compile(name:string);
Var f:text;
    s:string;
    line:longint;
Begin
 assign(f,name);
 reset(f);
 line:=1;
 while not eof(f) do
  Begin
   readln(f,s);
   Compile(s,name,line);
   inc(line);
  end;
 close(f)
end;

{ full 2-passed compiling file }
Procedure Source_Compile(name:string);
var i:integer;
Begin
 Writeln('Compiling: ',name);
 assign(err_file,err_filename);
 rewrite(err_file);
 { FIRST PASS }
 Compiler_Init;
  Remove_Counter;
  write('  Pass 1: ');
  File_Compile(name);
  if Get_Counter= 0 then writeln('done')
                    else writeln(Get_Counter,' error(s) founded.');
 { SECOND PASS }
 Compiler_Reinit;
  Remove_Counter;
  write('  Pass 2: ');
  File_Compile(name);
  close(err_file);
  if Get_Counter= 0 then writeln('done')
                    else writeln(Get_Counter,' error(s) founded.');
 { STORE CODE, IF IT NEED }
 Store_Code;
 { COME TO END }
 writeln;
 Compiler_Deinit
end;


Begin
   writeln;
   writeln('ZXASM (v1.0) Z-80 MacroAssembler');
   writeln('Copyright(C)2000 by SCREW /CM/OHG');
   writeln;
 if paramCount=0 then
  Begin
   writeln('USAGE: zxasm <asmprog>');
   writeln;
  end else Source_Compile(paramStr(1))
End.