{
  a Z-80 assembly language compiler for ZX-SPECTRUM (48/128/512/1024)

  DESCRIPT: mnemonic translator.

                                 was written by SCREW/OHG/CM
                                   all rights reserved

  FIXME: relative jumps now is not work correctly !!!
}

Unit C_Z80Codes;

INTERFACE

const delimset=[' ',',']; { valid delimeters in mnemonic }
      max_code_len=256;

Function GetWord(s:string; var i:integer):string;
Procedure ToUpper(Var s:string);

{ assebling one mnemonic }
Procedure Translate(s:string);
{convert string to value}
Procedure ReadValue(s:string;var res,err:integer);
{reset opcodes pippeline}
Procedure CodeReset;
{high/low part of register}
Procedure High_Low(var s:string);


Type op_code=Record
              code_len:byte;
              code_set:array[1..max_code_len] of byte;
             end;
 { GLOBAL VARIABLES }
Var    bytes:op_code; { code assembled command}
    indexing:boolean; { if index IX/IY base addresing }

         org:word;
        pass:byte;

IMPLEMENTATION

Uses C_ErrHandle, { using error handler  }
     C_Z80Labels, { using labels handler }
     C_Z80Macros; { using 'replace' }
{$I C_Z80DEF.pas} {include Z-80 opcodes definition }
{$I C_Z80ERR.pas} {include errors definition }
{***************************************************************************
                      ALL CODE IMPLEMENTATIONS
***************************************************************************}


{============== TEXT SOURCE IMPLEMENTATION ==========}
{ get next word from line }
Function GetWord(s:string; var i:integer):string;
var j,l:integer;
Begin
 l:=length(s);
 while(i<=l) and (s[i]=' ') do inc(i);
 j:=i;
 while(i<=l) and not (s[i] in delimset) do inc(i);
 GetWord:=copy(s,j,i-j);
 if s[i] in delimset then inc(i); {skip delimiter}
end;

Function isReserved(s:string):boolean; forward;

{convert string to value}
Procedure getVal(s:string; var value,err:integer);
const hexdec=['0'..'9','A'..'F'];
Var w,w1:word;
    len,i:integer;
Begin
 val(s,value,err);
 if err<>0 then Begin
                 { trying to BINARY and HEXDECIMAL }
                 len:=length(s);
                if len>1 then {check for another numeric system}
                 if s[len]='B' then Begin
                                   w:=1; err:=0;
                                   value:=0;
                                   for i:=len-1 downto 1 do
                                    Begin
                                     if s[i]='1' then value:=value+w else
                                     if s[i]<>'0' then err:=1;
                                     w:=w shl 1
                                    end
                                  end else
                 if s[len]='H' then Begin
                                   w:=1; err:=0;
                                   value:=0;
                                   for i:=len-1 downto 1 do
                                     if s[i] in hexdec then Begin
                                                             w1:=ord(s[i])-48;
                                                             if w1>9 then w1:=w1-7;
                                                             value:=value + w1*w;
                                                             w:=w*16
                                                            end
                                                        else err:=1
                                  end
                end;

 if err<>0 then Begin
                 err:=0;
                 { first, search into labels }
                 if not get_Label(lab, s, w) then
                 { if all trying crash then error generation }
                 if (pass=1) and not isReserved(s) then w:=org+2
                 else
                 err:=255;
                 { put w into value }
                 value:=w;
                end
end;

Procedure High(var s:string);
Var i,j,len:integer;
        arg:string;
Begin
 i:=1; len:=length(s);
 while(s[i]<>'H') and (s[i+1]<>'I') and (i<len) do inc(i);
 if (i<len-3) and (s[i+2]='(') then
                 Begin
                  { HI(xx) founded}
                  arg:=s[i+3]+s[i+4];
                  if arg='IX' then s:='XH' else
                  if arg='IY' then s:='YH' else
                  if arg='HL' then s:='H' else
                  if arg='BC' then s:='B' else
                  if arg='DE' then s:='D' else s:='err';
                 end
end;

Procedure High_Low(var s:string);
Var i,j,len:integer;
        arg:string;
Begin
 High(s);
 i:=1; len:=length(s);
 while(s[i]<>'L') and (s[i+1]<>'O') and (i<len) do inc(i);
 if (i<len-3) and (s[i+2]='(') then
                 Begin
                  { HI(xx) founded}
                  arg:=s[i+3]+s[i+4];
                  if arg='IX' then s:='XL' else
                  if arg='IY' then s:='YL' else
                  if arg='HL' then s:='L' else
                  if arg='BC' then s:='C' else
                  if arg='DE' then s:='E' else s:='err';
                 end
end;




{============ CALCULATOR IMPLEMENTATION =================================}
const
      opset=['+','-','*','/','%'];
      numset=['0'..'9'];

Procedure pass_spaces(var s:string);
Var res,s1:string;
      i:integer;
Begin
 res:=''; i:=1;
 while (i<=length(s)) do
  Begin
   if s[i]<>' ' then res:=res+s[i];
   inc(i)
  end;
 s:=res;
end;

Function ReadNumb(s:string;var i,err:integer):integer;
Var len,j:integer;
    tmp:string;
    sign:boolean;
Begin
 j:=i; len:=length(s);
 sign:=false;
 if s[i]='+' then inc(i) else
 if s[i]='-' then Begin inc(i); sign:=true end;
 while not (s[i] in opset) and (i<=len) do inc(i);
 tmp:=copy(s,j,i-j);
 getVal(tmp, j,err);
 if sign then j:=-j;
 ReadNumb:=j
end;

Procedure ReadValue(s:string;var res,err:integer);
Var i,i1,i2:integer;
    op:char;
Begin
 {pass_spaces(s);} res:=0;
 i:=1;
 i1:=ReadNumb(s,i,err); if err<>0 then exit;
 while(i<=length(s)) do
  Begin
   op:=s[i]; inc(i);
   i2:=ReadNumb(s,i,err); if err<>0 then exit;
   case op of
    '+': i1:=i1+i2;
    '-': i1:=i1-i2;
    '*': i1:=i1*i2;
    '/': i1:=i1 div i2;
    '%': i1:=i1 mod i2
   end
  end;
 res:=i1
end;






{=========== PIPPELINE IMPLEMENTATION ===============}
{reset opcodes pippeline}
Procedure CodeReset;
Begin
 bytes.code_len:=0
end;

{ add next opcode to pippeline}
Procedure CodeAdd(b:word);
Begin
 if (b>255) then Begin CodeAdd(hi(b)); CodeAdd(lo(b)) end else
with bytes do
 if code_len<max_code_len then
  Begin
   inc(code_len);
   code_set[code_len]:=b
  end
end;

{================ VERIFYING IMPLEMENTATION ============== }
   { ****************************************
                 NUMBER VERIFYING
     **************************************** }
Function isNumber(s:string; var i:integer):boolean;
Var err:integer;
Begin
 isNumber:=false;
 ReadValue(s,i,err); { using labels mechanism }
 if err<>0 then exit;
 isNumber:=true;
end;

Function is8Number(s:string; var i:integer):boolean;
Begin
 is8Number:=false;
 if isNumber(s,i) then
  if (i<=255) and (i>=-128) then is8Number:=true
end;

Function is16Number(s:string; var i:integer):boolean;
Begin
 is16Number:=false;
 if isNumber(s,i) then
  if (i<=65535) and (i>=-32768) then is16Number:=true
end;

Function is16Memory(s:string; var i:integer):boolean;
Var l:integer;
Begin
 is16Memory:=false;
 l:=length(s);
 if (s[1]='(') and (s[l]=')') then is16Memory:=is16Number(copy(s,2,l-2), i)
end;

   { ****************************************
                REGISTER VERIFYING
     **************************************** }
Function is8regs(s:string; var reg:byte):boolean;
Begin
 is8regs:=true;
if s='B' then reg:=reg_B else
if s='C' then reg:=reg_C else
if s='D' then reg:=reg_D else
if s='E' then reg:=reg_E else
if s='H' then reg:=reg_H else
if s='L' then reg:=reg_L else
if s='(HL)' then reg:=reg_atHL else
if s='A' then reg:=reg_A else is8Regs:=false
end;

Function is16regsSP(s:string; var reg:byte):boolean;
Begin
 is16regsSP:=true;
if s='BC' then reg:=reg_BC else
if s='DE' then reg:=reg_DE else
if s='HL' then reg:=reg_HL else
if s='SP' then reg:=reg_SP else is16regsSP:=false
end;

Function is16regsAF(s:string; var reg:byte):boolean;
Begin
 is16regsAF:=true;
if s='BC' then reg:=reg_BC else
if s='DE' then reg:=reg_DE else
if s='HL' then reg:=reg_HL else
if s='AF' then reg:=reg_AF else is16regsAF:=false
end;

Function isBlkType(s:string; var tp:byte):boolean;
Begin
 isBlkType:=true;
if s='IR' then tp:=tp_IR else
if s='DR' then tp:=tp_DR else
if s='I' then tp:=tp_I else
if s='D' then tp:=tp_D else isBlkType:=false
end;

   { ****************************************
                  FLAGS VERIFYING
     **************************************** }
Function isIFF(s:string; var iff:byte):boolean;
Begin
 isIFF:=true;
if s='NZ' then iff:=iff_NZ else
 if s='Z' then iff:=iff_Z else
if s='NC' then iff:=iff_NC else
 if s='C' then iff:=iff_C else
if s='PO' then iff:=iff_PO else
if s='PE' then iff:=iff_PE else
 if s='P' then iff:=iff_P else
 if s='M' then iff:=iff_M else isIFF:=false
end;

Function isReserved(s:string):boolean;
Var b:byte;
Begin
 isReserved:=is8regs(s,b) or is16regsSP(s,b)
end;


{ for index base addressing }
Function isOffset(var s:string; var offset:byte):boolean;
const offsdelim=['+','-'];
var i,j,l:integer;
    s1:string;
    offs:integer;
Begin
 isOffset:=false;
 if isNumber(copy(s,2,length(s)-2), offs) then exit; { this is addres }
 if indexing and (s='(HL)') then s:='(HL+0)'; {an empty offset}
 if (length(s)>=6) and (s[1]='(') then
  Begin
   { may be an index ??? check for it: }
   i:=3; l:=length(s);
   while not (s[i] in offsdelim) and (i<l) do inc(i);
   if not (s[i] in offsdelim) then exit; {Error(SYNTAX_ERROR); { +/- absent }
   j:=i;
{   if s[i]='+' then inc(j); { remove + in positive numbers }
   while (s[i]<>')') and (i<l) do inc(i);
   if s[i]<>')' then exit; {Error(SYNTAX_ERROR); { close bracket absent }
   s1:=copy(s,j,i-j);
   if not isNumber(s1,offs) then Error(SYNTAX_ERROR); { index is not number }
   if not is8Number(s1,offs) then Error(INVALID_OPCODE_SIZE);
   if copy(s,1,3)<>'(HL' then Error(INVALID_INDEXING_MODE);
   isOffset:=true;
   s:='(HL)';
   offset:=offs;
  end
end;


{================ MNEMONIC ASSEMBLING ===============}

   { ****************************************
                        LD
     **************************************** }
Procedure LD_mnem(arg1,arg2:string);
{ arg1: destination
  arg2: source }
Var b:integer;
    reg,reg2:byte;
    offset_present:boolean;
    offs:byte;
      op:word;
Begin
 { check for indexing addressing }
   offset_present:=isOffset(arg1,offs);
   if not offset_present then offset_present:=isOffset(arg2,offs);
   if offset_present and not indexing then Error(INVALID_INDEXING_MODE);

 if (arg1='A') and (arg2='(BC)') then CodeAdd(mnem_LD_A_BC) else
 if (arg1='A') and (arg2='(DE)') then CodeAdd(mnem_LD_A_DE) else
 if (arg1='(BC)') and (arg2='A') then CodeAdd(mnem_LD_BC_A) else
 if (arg1='(DE)') and (arg2='A') then CodeAdd(mnem_LD_DE_A) else
 if is16Memory(arg2,b) then
  Begin
   { LD reg,(NN) }
   if arg1='A' then op:=mnem_LD_A_mem16 else
   if is16regsSP(arg1,reg) then
    Begin
     op:=mnem_LD_reg16_mem16 or reg;
     if arg1='HL' then op:=mnem_LD_HL_mem16
    end else Error(SYNTAX_ERROR);
   CodeAdd(op);
   CodeAdd(lo(b));
   CodeAdd(hi(b))
  end else
 if is16Memory(arg1,b) then
  Begin
   { LD (NN),reg }
   if arg2='A' then op:=mnem_LD_mem16_A else
   if is16regsSP(arg2,reg) then
    Begin
     op:=mnem_LD_mem16_reg16 or reg;
     if arg2='HL' then op:=mnem_LD_mem16_HL
    end else Error(SYNTAX_ERROR);
   CodeAdd(op);
   CodeAdd(lo(b));
   CodeAdd(hi(b))
  end else
 if is8regs(arg1,reg) and isNumber(arg2,b) then
  Begin
   { LD reg8, num8 }
       { check for opcode size }
       if not is8Number(arg2,b) then Error(INVALID_OPCODE_SIZE);
   reg:=reg shl 3;
   reg:=reg or mnem_LD_reg8num8;
   CodeAdd(reg);
   if offset_present then CodeAdd(offs);
   CodeAdd(b)
  end else
 if is8regs(arg1,reg) and is8regs(arg2,reg2) then
  Begin
   { LD reg8, reg8 }
       { check for invalid: LD (HL),(HL) }
       if (reg=reg2) and (reg=reg_atHL) then Error(INVALID_USING_REGISTERS);
   reg:=reg shl 3; { this is destination}
   reg:=reg or reg2 or mnem_LD_reg8reg8;
   CodeAdd(reg);
   if offset_present then CodeAdd(offs);
  end else
 if is16regsSP(arg1,reg) and isNumber(arg2,b) then
  Begin
   { LD reg16, num16 }
       { check for opcode size }
       if not is16Number(arg2,b) then Error(INVALID_OPCODE_SIZE);
   reg:=reg or mnem_LD_reg16num16;
   CodeAdd(reg);
   CodeAdd(lo(b));
   CodeAdd(hi(b));
  end else
 if is16regsSP(arg1,reg) and is16regsSP(arg2,reg2) then
  Begin
   { LD SP,HL}
   if (reg=reg_SP) and (reg2=reg_HL) then CodeAdd(mnem_LD_SPfromHL)
                                    else Error(INVALID_USING_REGISTERS)
  end else
 if is8regs(arg1,reg) then
  Begin
   if (reg=reg_A) and (arg2='R') then CodeAdd(mnem_LD_AfromR) else
   if (reg=reg_A) and (arg2='I') then CodeAdd(mnem_LD_AfromI) else
   Error(SYNTAX_ERROR)
  end else
 if (arg1='R') or (arg1='I') and is8regs(arg2,reg) then
  Begin
   if (arg1='R') and (reg=reg_A) then CodeAdd(mnem_LD_RfromA) else
   if (arg1='I') and (reg=reg_A) then CodeAdd(mnem_LD_IfromA) else
   Error(SYNTAX_ERROR)
  end else
 Error(SYNTAX_ERROR)
end;

   { ****************************************
                    INC & DEC
     **************************************** }
Procedure INC_mnem(name,arg1,arg2:string);
Var reg:byte;
    offset_present:boolean;
    offs:byte;
      op:byte;
Begin
 if arg2<>'' then Error(SYNTAX_ERROR);
 { check for index addressing }
 offset_present:=isOffset(arg1,offs);
 if offset_present and not indexing then Error(INVALID_INDEXING_MODE);

 if is8regs(arg1,reg) then
  Begin
   { INC reg8 }
   if name='INC' then op:=mnem_INC_reg8 else op:=mnem_DEC_reg8;
   reg:=reg shl 3 or op;
   CodeAdd(reg);
   if offset_present then CodeAdd(offs)
  end else
 if is16regsSP(arg1,reg) then
  Begin
   { INC reg16 }
   if name='INC' then op:=mnem_INC_reg16 else op:=mnem_DEC_reg16;
   reg:=reg or op;
   CodeAdd(reg)
  end else
 Error(SYNTAX_ERROR)
end;

   { ****************************************
                        CALL
     **************************************** }
Procedure CALL_mnem(arg1,arg2:string);
Var b:byte;
    iff:byte;
    addr:integer;
Begin
 if is16Number(arg1,addr) and (arg2='') then b:=mnem_CALL
else
 if is16Number(arg2,addr) then
  if isIFF(arg1,iff) then b:=iff or mnem_CALL_IF
                     else Error(WRONG_IF_CONDITION)
else Error(SYNTAX_ERROR);
 CodeAdd(b);
 CodeAdd(lo(addr));
 CodeAdd(hi(addr))
end;
   { ****************************************
                         JP
     **************************************** }
Procedure JP_mnem(arg1,arg2:string);
Var b:byte;
    iff:byte;
    addr:integer;
Begin
 if is16Number(arg1,addr) and (arg2='') then b:=mnem_JP
else
 if arg2='' then Begin
                 if arg1='(HL)' then b:=mnem_JPatHL else Error(INVALID_INDEXING_MODE)
                 end
else
 if is16Number(arg2,addr) then
  if isIFF(arg1,iff) then b:=iff or mnem_JP_IF
                     else Error(WRONG_IF_CONDITION)
else Error(SYNTAX_ERROR);
 CodeAdd(b);
 if b<>mnem_JPatHL then Begin
                         CodeAdd(lo(addr));
                         CodeAdd(hi(addr))
                        end
end;

   { ****************************************
                     JR & DJNZ
     **************************************** }
Procedure JR_mnem(name,arg1,arg2:string);
Var b:byte;
    iff:byte;
    addr:integer;
Begin
 if is16Number(arg1,addr) and (arg2='') then
  if name='JR' then b:=mnem_JR else b:=mnem_DJNZ
else
 if is16Number(arg2,addr) then
  Begin
   if isIFF(arg1,iff) and (iff<iff_PO) then b:=iff or mnem_JR_IF
                      else Error(WRONG_IF_CONDITION)
  end else Error(SYNTAX_ERROR);
 addr:=addr-org-2;
 if (addr<-128) or (addr>127) then Error(RELATIVE_JUMP_IS_TOO_FAR);
 CodeAdd(b);
 CodeAdd(lo(addr));
end;

   { ****************************************
                        RET
     **************************************** }
Procedure RET_mnem(arg1,arg2:string);
Var b:byte;
    iff:byte;
    addr:integer;
Begin
 if arg2<>'' then Error(SYNTAX_ERROR);
 if arg1='' then b:=mnem_RET
else
 if isIFF(arg1,iff) then b:=iff or mnem_RET_IF
                    else Error(WRONG_IF_CONDITION);
 CodeAdd(b)
end;

   { ****************************************
                    PUSH & POP
     **************************************** }
Procedure PUSH_mnem(name,arg1,arg2:string);
Var reg:byte;
     op:byte;
Begin
 if name='PUSH' then op:=mnem_PUSH else op:=mnem_POP;

 if arg2<>'' then Error(SYNTAX_ERROR);
 { check for index addressing }
 if is16regsAF(arg1,reg) then
  Begin
   { PUSH reg16 }
   reg:=reg or op;
   CodeAdd(reg)
  end else
 Error(SYNTAX_ERROR)
end;

   { ****************************************
                   ADD & ADC
     **************************************** }
Procedure ADD_mnem(name,arg1,arg2:string);
{ arg1: destination
  arg2: source }
Var b:integer;
    reg,reg2:byte;
    offset_present:boolean;
    offs:byte;
      op:byte;
Begin
 { check for indexing addressing }
 offset_present:=isOffset(arg2,offs);
 if offset_present and not indexing then Error(INVALID_INDEXING_MODE);

 { check for invalid: ADD reg,N }
 if is8regs(arg1,reg) then
   if reg<>reg_A then Error(INVALID_USING_REGISTERS);

 if is8regs(arg1,reg) and isNumber(arg2,b) then
  Begin
   { ADD A, num8 }
       { check for opcode size }
       if not is8Number(arg2,b) then Error(INVALID_OPCODE_SIZE);
   if name='ADD' then op:=mnem_ADD_Anum8 else op:=mnem_ADC_Anum8;
   CodeAdd(op);
   CodeAdd(b)
  end else
 if is8regs(arg1,reg) and is8regs(arg2,reg2) then
  Begin
   { ADD A, reg8 }
   if name='ADD' then op:=mnem_ADD_Areg8 else op:=mnem_ADC_Areg8;
   reg:=reg2 or op;
   CodeAdd(reg);
   if offset_present then CodeAdd(offs)
  end else
 if is16regsSP(arg1,reg) and is16regsSP(arg2,reg2) then
  Begin
   { ADD HL, reg16 }
       if reg<>reg_HL then Error(INVALID_USING_REGISTERS);
   if name='ADD' then op:=mnem_ADD_HLreg16 else op:=mnem_ADC_HLreg16;
   reg:=reg2 or op;
   CodeAdd(reg)
  end else
 Error(SYNTAX_ERROR)
end;

   { ****************************************
         SUB & OR & XOR & AND & CP &
     SRL, SRA, SLA, SLI, RL, RR, RLC, RRC
     **************************************** }
Procedure SUB_mnem(name,arg1,arg2:string);
{ arg1: destination
  arg2: source }
Var b:integer;
    reg,reg2:byte;
    offset_present:boolean;
    offs:byte;
      op:word;
Begin
 if arg2<>'' then Error(SYNTAX_ERROR);
 { check for indexing addressing }
 offset_present:=isOffset(arg1,offs);
 if offset_present and not indexing then Error(INVALID_INDEXING_MODE);


 if isNumber(arg1,b) then
  Begin
   { SUB num8 }
       { check for opcode size }
       if not is8Number(arg1,b) then Error(INVALID_OPCODE_SIZE);
   if name='SUB' then op:=mnem_SUB_Anum8 else
   if name='XOR' then op:=mnem_XOR_Anum8 else
   if name='AND' then op:=mnem_AND_Anum8 else
   if name='OR' then op:=mnem_OR_Anum8 else
   if name='CP' then op:=mnem_CP_Anum8 else Error(SYNTAX_ERROR);
   CodeAdd(op);
   CodeAdd(b)
  end else
 if is8regs(arg1,reg) then
  Begin
   { SUB reg8 }
   if name='SUB' then op:=mnem_SUB_Areg8 else
   if name='XOR' then op:=mnem_XOR_Areg8 else
   if name='AND' then op:=mnem_AND_Areg8 else
   if name='OR' then op:=mnem_OR_Areg8 else
   if name='CP' then op:=mnem_CP_Areg8 else
   if name='SRL' then op:=mnem_SRL_reg8 else
   if name='SRA' then op:=mnem_SRA_reg8 else
   if name='SLA' then op:=mnem_SLA_reg8 else
   if name='SLI' then op:=mnem_SLI_reg8 else
   if name='RL' then op:=mnem_RL_reg8 else
   if name='RR' then op:=mnem_RR_reg8 else
   if name='RLC' then op:=mnem_RLC_reg8 else
   if name='RRC' then op:=mnem_RRC_reg8;
   op:=reg or op;
   if hi(op)<>0 then CodeAdd(hi(op)) else CodeAdd(lo(op));
   if offset_present then
                           CodeAdd(offs);
   if hi(op)<>0 then CodeAdd(lo(op))
  end else
 Error(SYNTAX_ERROR)
end;

   { ****************************************
                  SET & RES & BIT
     **************************************** }
Procedure SET_mnem(name,arg1,arg2:string);
{ arg1: destination
  arg2: source }
Var b:integer;
    reg,reg2:byte;
    offset_present:boolean;
    offs:byte;
      op:word;
Begin
 val(arg1,reg,b);
 if (b<>0) or (reg>7) then Error(SYNTAX_ERROR);
 reg:=reg shl 3;
 { check for indexing addressing }
 offset_present:=isOffset(arg2,offs);
 if offset_present and not indexing then Error(INVALID_INDEXING_MODE);

 if is8regs(arg2,reg2) then
  Begin
   { SUB reg8 }
   if name='SET' then op:=mnem_SET_reg8 else
   if name='RES' then op:=mnem_RES_reg8 else
   if name='BIT' then op:=mnem_BIT_reg8;
   op:=reg or op or reg2;
   CodeAdd(hi(op));
   if offset_present then CodeAdd(offs);
   CodeAdd(lo(op))
  end else
 Error(SYNTAX_ERROR)
end;

   { ****************************************
                      RST
     **************************************** }
Procedure RST_mnem(arg1,arg2:string);
{ arg1: destination
  arg2: source }
Var b:integer;
    reg:byte;
Begin
 if arg2<>'' then Error(SYNTAX_ERROR);
 val(arg1,reg,b);
 if (b<>0) or (reg mod 8>7) or (reg>56) then Error(SYNTAX_ERROR);
{ reg:=reg shl 3;}
   reg:=reg or mnem_RST;
   CodeAdd(reg)
end;

   { ****************************************
                        SBC
     **************************************** }
Procedure SBC_mnem(arg1,arg2:string);
{ arg1: destination
  arg2: source }
Var b:integer;
    reg,reg2:byte;
    offset_present:boolean;
    offs:byte;
    w:word;
Begin
 { check for indexing addressing }
 offset_present:=isOffset(arg2,offs);
 if offset_present and not indexing then Error(INVALID_INDEXING_MODE);

 { check for invalid: SBC reg,N }
 if is8regs(arg1,reg) then
   if reg<>reg_A then Error(INVALID_USING_REGISTERS);

 if is8regs(arg1,reg) and isNumber(arg2,b) then
  Begin
   { SBC A, num8 }
       { check for opcode size }
       if not is8Number(arg2,b) then Error(INVALID_OPCODE_SIZE);
   CodeAdd(mnem_SBC_Anum8);
   CodeAdd(b)
  end else
 if is8regs(arg1,reg) and is8regs(arg2,reg2) then
  Begin
   { SBC A, reg8 }
   reg:=reg2 or mnem_SBC_Areg8;
   CodeAdd(reg);
   if offset_present then CodeAdd(offs)
  end else
 if is16regsSP(arg1,reg) and is16regsSP(arg2,reg2) then
  Begin
   { SBC HL, reg16 }
       if reg<>reg_HL then Error(INVALID_USING_REGISTERS);
   w:=reg2 or mnem_SBC_HLreg16;
   CodeAdd(w)
  end else
 Error(SYNTAX_ERROR)
end;

   { ********************************************
      LDIR, LDDR, LDI, LDD, CPIR, CPDR, CPI, CPD
     INIR, INDR, INI, IND, OTIR, OTDR, OUTI, OUTD
     ******************************************** }
Function BLK(arg1,arg2:string):boolean;
Var tp:byte;
    op:word;
Begin
if arg2='L' then CodeAdd(mnem_CPL) else
if isBlkType(arg2,tp) then
 Begin
  if arg1='LD' then op:=mnem_LD_blk else
  if arg1='CP' then op:=mnem_CP_blk else
  if arg1='IN' then op:=mnem_IN_blk else
  if arg1='OT' then op:=mnem_OUT_blk else Error(SYNTAX_ERROR);
  op:=op or tp;
  CodeAdd(op)
 end
else Error(SYNTAX_ERROR)

end;

   { ****************************************
                      OUT
     **************************************** }
Procedure OUT_mnem(arg1,arg2:string);
{ arg1: destination
  arg2: source }
Var b:integer;
    reg:byte;
Begin
 if arg1='(C)' then
  Begin
   if arg2='(HL)' then Error(INVALID_USING_REGISTERS);
   if arg2='0' then arg2:='(HL)';
   if not is8regs(arg2,reg) then Error(SYNTAX_ERROR);
   b:=reg shl 3 or mnem_OUT_reg8;
   CodeAdd(b)
  end else
 if arg2='A' then
  Begin
   if not is16Memory(arg1,b) then Error(SYNTAX_ERROR);
   if (b<-128) or (b>255) then Error(INVALID_OPCODE_SIZE);
   CodeAdd(mnem_OUT_port8_A);
   CodeAdd(b)
  end else
 Error(SYNTAX_ERROR)
end;

   { ****************************************
                      IN
     **************************************** }
Procedure IN_mnem(arg1,arg2:string);
{ arg1: destination
  arg2: source }
Var b:integer;
    reg:byte;
Begin
 if arg2='(C)' then
  Begin
   if arg1='(HL)' then Error(INVALID_USING_REGISTERS);
   if arg1='F' then arg1:='(HL)';
   if not is8regs(arg1,reg) then Error(SYNTAX_ERROR);
   b:=reg shl 3 or mnem_IN_reg8;
   CodeAdd(b)
  end else
 if arg1='A' then
  Begin
   if not is16Memory(arg2,b) then Error(SYNTAX_ERROR) else
   if (b<-128) or (b>255) then Error(INVALID_OPCODE_SIZE) else
    Begin
     CodeAdd(mnem_IN_A_port8);
     CodeAdd(b)
    end
  end else
 Error(SYNTAX_ERROR)
end;


   { ****************************************
                      DB + DW
     **************************************** }
Procedure Defb(s:string);
Var i,j,err,len:integer;
    s1,s2,tp:string;
Begin
 j:=1; tp:=GetWord(s,j);
 s:=Replace(s,tp,'');
{ pass_spaces(s);}
 j:=1; len:=length(s);
 Repeat
  s1:=''; while(s[j]<>',') and (j<=len) do Begin s1:=s1+s[j]; inc(j) end;
  inc(j);
  s2:=s1; pass_spaces(s1);
{  val(s1,i,err);}
  if s1<>'' then
   if (tp='DB') and (s1[1]=chr(39)) and (s1[length(s1)]=chr(39)) and (err<>0)
    then Begin
          {strings add}
          len:=length(s2);
          i:=1; while (s2[i]<>chr(39)) and (i<len) do inc(i);
          inc(i); while (s2[i]<>chr(39)) and (i<len) do
                                          Begin
                                           CodeAdd( lo(ord(s2[i])) );
                                           inc(i)
                                          end
         end else
  if isNumber(s1,i) then Begin
                          {numbers add}
                          if tp='DB' then CodeAdd( lo(i) );
                          if tp='DW' then Begin
                                           CodeAdd( lo(i) );
                                           CodeAdd( hi(i) )
                                          end
                         end
                   else Error(SYNTAX_ERROR)
 until s1=''
end;

   { ****************************************
                ALL OTHER COMMANDS
     **************************************** }
Function Extern(name,arg1,arg2:string):boolean;
Var b:integer;
   reg:byte;
Begin
 Extern:=true;
 if (arg1='') and (arg2='') then
  Begin
   if name='RLCA' then CodeAdd(mnem_RLCA) else
   if name='RRCA' then CodeAdd(mnem_RRCA) else
   if name='RLA' then CodeAdd(mnem_RLA) else
   if name='RRA' then CodeAdd(mnem_RRA) else
   if name='RLD' then CodeAdd(mnem_RLD) else
   if name='RRD' then CodeAdd(mnem_RRD) else
   if name='NOP' then CodeAdd(mnem_NOP) else
   if name='NEG' then CodeAdd(mnem_NEG) else
   if name='SCF' then CodeAdd(mnem_SCF) else
   if name='CCF' then CodeAdd(mnem_CCF) else
   if name='DAA' then CodeAdd(mnem_DAA) else
   if name='HALT' then CodeAdd(mnem_HALT) else
   if name='EXX' then CodeAdd(mnem_EXX) else
   if name='EI' then CodeAdd(mnem_EI) else
   if name='DI' then CodeAdd(mnem_DI) else
   if name='RETI' then CodeAdd(mnem_RETI) else
   if name='RETN' then CodeAdd(mnem_RETN) else Extern:=false
  end else
 if (name='IM') and (arg2='') then
  Begin
   if arg1='0' then CodeAdd(mnem_IM0) else
   if arg1='1' then CodeAdd(mnem_IM1) else
   if arg1='2' then CodeAdd(mnem_IM2) else Extern:=false
  end else
 if (name='EX') then
  Begin
   if (arg1='DE') and (arg2='HL') then CodeAdd(mnem_EX_DE_HL) else
   if (arg1='AF') and (arg2='AF'+chr(39)) then CodeAdd(mnem_EX_AF_AF) else
   if (arg1='(SP)') and (arg2='HL') then CodeAdd(mnem_EX_SP_HL)
    else  if ( is16regsSP(arg1,reg) or is16regsSP(arg1,reg) ) and
             ( is16regsSP(arg1,reg) or is16regsSP(arg1,reg) )
          then Error(INVALID_USING_REGISTERS)
          else Extern:=false
  end else Extern:=false;
end;

{=============== INDEXING ADDRESSING IMPLEMENTATION ===================}
{ check one argument for IX - IY present }
Procedure check_one(var s:string; var ix,iy:boolean);
Var s1:string;
     i:integer;
Begin
 ix:=false; iy:=false;
 for i:=1 to length(s)-1 do
  Begin
   s1:=copy(s,i,2);
   if (s1='IX') or (s1='XH') or (s1='XL') then ix:=true;
   if (s1='IY') or (s1='YH') or (s1='YL') then iy:=true;
   { ix modify }
   if ix then  if s1='IX' then s1:='HL' else
               if s1='(IX)' then s1:='(HL)' else
               if s1='XH' then s1:='H' else
               if s1='XL' then s1:='L';
   { iy modify }
   if iy then  if s1='IY' then s1:='HL' else
               if s1='(IY)' then s1:='(HL)' else
               if s1='YH' then s1:='H' else
               if s1='YL' then s1:='L';
   s:=copy(s,1,i-1)+s1+copy(s,i+2,length(s)-i-1);
  end
end;

Function isHL(arg:string):boolean;
Begin
 if (arg='HL') or (arg='(HL)') or
    (arg='H') or (arg='L') then isHL:=true else isHL:=false
end;


{ work with IX & IY with modifyers }
Procedure check_IXIYModify(Var arg1,arg2:string);
Var ix,ix1:boolean;
    iy,iy1:boolean;
Begin
 indexing:=false;
 check_one(arg1,ix,iy);
 check_one(arg2,ix1,iy1);
 if (ix or iy) and (arg2='(HL)') then Error(INVALID_USING_REGISTERS);
  { check for valid HL change if indexing }
     { mnem IX/IY, HL }
  if ix and isHL(arg2) and not ix1 then Error(INVALID_USING_REGISTERS);
  if iy and isHL(arg2) and not iy1 then Error(INVALID_USING_REGISTERS);
     { mnem HL, IX/IY }
  if ix1 and isHL(arg1) and not ix then Error(INVALID_USING_REGISTERS);
  if iy1 and isHL(arg1) and not iy then Error(INVALID_USING_REGISTERS);


 ix:=ix or ix1;
 iy:=iy or iy1;
 if ix and iy then Error(SYNTAX_ERROR);
 if ix then CodeAdd(Modif_IX);
 if iy then CodeAdd(Modif_IY);
 if ix or iy then indexing:=true;
End;

{ assebling one mnemonic }
Procedure Translate(s:string);
Var i,j,len:integer;
   mnem,arg1,arg2:string;
   suff,endc:string;
Begin
 i:=1;
 mnem:=GetWord(s,i);

{  arg1:=GetWord(s,i);
  arg2:=GetWord(s,i);}
 j:=i; len:=length(s);
 while (s[i]<>',') and (i<=len) do inc(i);
 arg1:=copy(s,j,i-j);
 arg2:=copy(s,i+1,len-i);
 pass_spaces(arg1); { for evaulate: '-4  + 2 %7 '}
 pass_spaces(arg2);

 High_Low(arg1);
 High_Low(arg2);

 Check_IXIYModify(arg1,arg2);

 if mnem='OUTI' then mnem:='OTI';
 if mnem='OUTD' then mnem:='OTD';
 suff:=copy(mnem,1,2);
 endc:=copy(mnem,3,length(mnem)-2);

 if mnem='LD' then LD_mnem(arg1,arg2)
else
 if (mnem='INC') or (mnem='DEC') then INC_mnem(mnem,arg1,arg2)
else
 if mnem='CALL' then CALL_mnem(arg1,arg2)
else
 if mnem='JP' then JP_mnem(arg1,arg2)
else
 if (mnem='JR') or (mnem='DJNZ') then JR_mnem(mnem,arg1,arg2)
else
 if mnem='RET' then RET_mnem(arg1,arg2)
else
 if (mnem='PUSH') or (mnem='POP') then PUSH_mnem(mnem,arg1,arg2)
else
 if (mnem='ADD') or (mnem='ADC') then ADD_mnem(mnem,arg1,arg2)
else
 if (mnem='SUB') or (mnem='AND') or (mnem='XOR') or
    (mnem='OR') or (mnem='CP') or
    (mnem='SRL') or (mnem='SRA') or (mnem='SLA') or
    (mnem='SLI') or (mnem='RL') or (mnem='RR') or
    (mnem='RLC') or (mnem='RRC') then SUB_mnem(mnem,arg1,arg2)
else
 if (mnem='SET') or (mnem='RES') or (mnem='BIT') then SET_mnem(mnem,arg1,arg2)
else
 if mnem='SBC' then SBC_mnem(arg1,arg2)
else
 if mnem='RST' then RST_mnem(arg1,arg2)
else
 if mnem='OUT' then OUT_mnem(arg1,arg2)
else
 if mnem='IN' then IN_mnem(arg1,arg2)
else
 if mnem='INF' then IN_mnem('F','(C)')
else
 if (suff<>mnem) and (suff='LD') or (suff='IN')
    or (suff='CP') or (suff='OT') then BLK(suff,endc)
else
 if (mnem='DB') or (mnem='DW') then Defb(s)
else
 if not extern(mnem,arg1,arg2) then Error(UNKNOWN_MNEMONIC);
end;

Procedure ToUpper(Var s:string);
Var i,l:integer;
Begin
 l:=length(s);
 for i:=1 to l do s[i]:=UpCase(s[i])
end;


end.