{
  a Z-80 assembly language compiler for ZX-SPECTRUM (48/128/512/1024)

  DESCRIPT: EQU's, ='s & defines handler.

                                 was written by SCREW/OHG/CM
                                   all rights reserved
}
Unit C_Z80Equals;

INTERFACE

Const max_Equals=1900;
      max_equ_len=16;
Type equal=Record
            name,value:string[max_equ_len]
           end;
     equ_table=Record
                equs:array[1..max_Equals] of equal;
                last_found:integer;
                total:integer
               end;
      equ_Ptr=^equ_table;

Var equ:equ_Ptr;

Procedure EQU_Init(var E:equ_Ptr);
Procedure EQU_Deinit(var E:equ_Ptr);
Function EQU_Add(var E:equ_Ptr; text:string):boolean;
Procedure EQU_Use(var E:equ_Ptr;var text:string);

IMPLEMENTATION

Uses C_ErrHandle, { using error handler }
     C_Z80Macros, { using 'Replace' }
     C_Z80Codes;  { using 'GetWord' }
{$I C_Z80ERR.pas} {include errors definition }

{***************************************************************************
                      ALL CODE IMPLEMENTATIONS
***************************************************************************}

Procedure EQU_Init(var E:equ_Ptr);
Begin
 new(E);
 E^.total:=0
end;

Procedure EQU_Deinit(var E:equ_Ptr);
Begin
 dispose(E)
end;

Function isExist(E:equ_Ptr; text:string):boolean;
Var i:integer;
Begin
 isExist:=false;
 for i:=1 to E^.total do
  if E^.equs[i].name=text then Begin
                                isExist:=true;
                                E^.last_found:=i;
                                break
                               end
end;


Function EQU_Add(var E:equ_Ptr; text:string):boolean;
var num,i:integer;
    name,arg1,arg2:string;
Begin
 EQU_Add:=false;
 i:=1;
 name:=GetWord(text,i);
 arg1:=GetWord(text,i);
 arg2:=GetWord(text,i);
 if name='#DEFINE' then name:='EQU';
 if (arg1='EQU') or (arg1='=') then Begin
                                     arg1:=name;
                                     name:='EQU'
                                    end;
 if name<>'EQU' then exit;
 if arg2='' then arg2:='1';
                if arg1='' then Begin
                                 Error(SYNTAX_ERROR);
                                 exit
                                end;
 { EQU addition }
 if isExist(E,name) then Error(EQUAL_ALREADY_EXISTS)
else
 if E^.total>=max_Equals then Error(TOO_MANY_EQUALS)
else
 Begin
  inc(E^.total);
  E^.equs[E^.total].name:=arg1;
  E^.equs[E^.total].value:=arg2
 end;
 EQU_Add:=true
end;

Procedure EQU_Use(var E:equ_Ptr;var text:string);
var i:integer;
    s:string;
Begin
 repeat
  s:=text;
  for i:=1 to E^.total do
   text:=Replace(text,E^.equs[i].name,E^.equs[i].value)
 until s=text
end;


end.